#require 'pp'
require 'vr/vruby'
require 'vr/vrdialog'
require 'vr/vrcontrol'
require 'vr/vrlayout'
require 'vr/vrtimer'
require 'vr/vrhandler'
require 'date'

require 'hk/hktool'
require 'hk/hktable'
require 'hk/setting'

$settingfile = "hk/setting.txt"
$current_dir = Dir.pwd


module HKShowMenu
#  include VRVertLayoutManager
  include VRMenuUseable
  include VRStdControlContainer
  include VRTimerFeasible
  include VRClosingSensitive
  
  def construct
    read_settingfile($settingfile)
    
    @@checked = VRMenuItem::CHECKED
    self.hookwndproc
    self.caption="Ԃ̋LOWvc["
    move $s["mainx"],$s["mainy"],420,270
    show_menu
    addControl SelectDiff ,"selectdiff","",10,10,400,30
    addControl SelectType ,"selecttype","",10,40,400,30
    @total = addControl VRStatic,"","",0,70,400,170
    
    set_params("")
    until init_shukei($s["logfile"]) ;end
    
    @rm_create = false
    recentmatch_clicked if $s["logshow"]
    
    @add_date.checked = false
    if $s["add_date"] then
      @add_date.checked = false
      $s["add_date"] = false
      add_date_clicked
    end
    addTimer
  end
  
#j[쐬
  def show_menu
    mlist = []
    mlist.push ["t@C", [
        ["OJ","openlog"],
        VRMenu::SEPARATOR,
        ["WvʂۑďI","save"],
        ["I","exit"]
      ]]
      
    mview = []
    $diffname_table.each {|name|
      item = [name, name.downcase]
      item.push(VRMenuItem::CHECKED) if $s[name.downcase]
      mview.push item
    }
    mview.push VRMenu::SEPARATOR
    $typename_table.each {|name|
      item = [name, name.downcase, $s[name.downcase] ? @@checked : nil]
      mview.push item
    }
    mview.push VRMenu::SEPARATOR
    $sheet_table0.each {|name,key|
      mview.push [name, key, ($s["sheet"] == name) ? @@checked : nil]
    }
    mt = []
    $sheet_table1.each {|name,key|
      mt.push [name, key, ($s["sheet"] == name) ? @@checked : nil]
    }
    mview.push ["̑", mt]
    mlist.push ["\", mview]
    
    
    if ($s['replay_folder'] == '' || $s['replay_auto_save_folder'] == '')
      t = VRMenuItem::GRAYED
    elsif $s["copy_new_replay"]
      t = @@checked
    else
      t = nil
    end
    mlist.push ["c[", [ 
        ["ŋ߂̑ΐ\", "recentmatch"],
        ["Oɑΐǉ","add_date"],
        ["VKvCvCtH_ɔzu", "copynewreplay", t]
      ]]
      
    list = []
    list.push ["эŐVm", "total_recent", $s["total_recent"] ? @@checked : nil]
    list.push ["ō~Ƀ\[g", "sort", $s["sort"] ? @@checked : nil]
    list.push VRMenu::SEPARATOR
    t = []
    for i in 0..9
      t.push [$s["co" + i.to_s + "caption"], "co" + i.to_s]
    end
    list.push ["L̕\", t]
    t = []
    for i in 0..9
      t.push [$s["custom" + i.to_s + "caption"], "custom" + i.to_s]
    end
    list.push ["JX^ݒ", t]
    list.push VRMenu::SEPARATOR
    t = []
    for i in 0..9
      t.push ["JX^ݒ" + i.to_s + "ɕۑ", "save_custom" + i.to_s]
    end
    list.push ["JX^ݒ̕ۑ", t]
    mlist.push ["ݒ", list]
    
    setMenu newMenu.set(mlist)
  end
  
#т̕\
  def show_total
    @shukei.get_total
    caption = "\n   "
    if $s["total_recent"]
      caption += "iŐV" + $s["total_limit"].to_s + "j"
    end
    caption += "\n  ΐ  " + @shukei._nmatch.to_s
    if @shukei._win_n>0 then
      rate = (@shukei._nwin.to_f*100/@shukei._win_n).to_s[0,5]
    else
      rate = ""
    end
    caption += "      " + rate + "%\n"
    if @shukei._playtime_n>0 then
      a = @shukei._playtimetotal / @shukei._playtime_n
      a = a / 60
      b = a % 60
      a = a / 60
      rate = a.to_s + ":" + (b<10 ? "0" : "") + b.to_s
    else
      rate = ""
    end
    caption += "  ϑΐ펞ԁiEhj  " + rate + "\n"
    a = @shukei._playtimemax
    a = a / 60
    b = a % 60
    a = a / 60
    caption += "  Œΐ펞ԁiꎎj  " + a.to_s + ":" + (b<10 ? "0" : "") + b.to_s + "\n"
    a = @shukei._playtimemaxR[3]
    a = a / 60
    b = a % 60
    a = a / 60
    caption += "  Œΐ펞ԁiEhj  " + a.to_s + ":" + (b<10 ? "0" : "") + b.to_s + "\n"
    a = @shukei._playtimetotal
    a = a / 60
    c = a % 60
    a = a / 60
    b = a % 60
    a = a / 60
    caption += "  ΐ펞  " + a.to_s + ":" + (b<10 ? "0" : "") + b.to_s + ":" + (c<10 ? "0" : "") + c.to_s + "\n"
    caption += "  Po^Qo  " + @shukei._n1P.to_s + "/" + @shukei._n2P.to_s
    @total.caption = caption
  end
  
#Wv̏
  def init_shukei(filename = nil)
    unless filename && File.exist?(filename)
      filename=SWin::CommonDialog::openFilename(self,[ ["CSVt@C(*.csv)","*.csv"],["SẴt@C(*.*)","*.*"] ])
    end
    return false unless filename && File.exist?(filename)
    @init_finished = false
    @logfile.close if @logfile
    Dir.chdir($current_dir)
    $s["logfile"] = filename
    
    @logfile = open(filename, "r")
    @shukei = HKShukei.new(@logfile)
    @init_finished = true
    refreshsheet
    show_total
    return true
  end
  
#bƂɃO̍XV`FbN
  def self_timer
    if @rm_create
      if ! @rm.alive?
        @rm_create = false
        $s["logshow"] = false
      end
    end
    
    return unless @init_finished && (line = @logfile.gets)
    if @add_date.checked?
      @logfile2.puts line.chomp + ',' + DateTime.now.strftime("%Y/%m/%d %H:%M:%S")
      @logfile2.flush
    end
    item = @shukei.update(line)
    
    @recentmatchtext += $s["name" + item.chara.to_s] + ","
    @recentmatchtext += $s["ename" + item.echara.to_s] + ","
    t = "2-0" if item.win == 1 and item.nround == 2
    t = "2-1" if item.win == 1 and item.nround == 3
    t = "1-2" if item.win == 0 and item.nround == 3
    t = "0-2" if item.win == 0 and item.nround == 2
    @recentmatchtext += t + ","
    @recentmatchtext += (item.side+1).to_s + "P,"
    for i in 0..2
      break if item.nround == 2 and i == 2
      a = item.playtimeR[i]
      a = a / 60
      b = a % 60
      a = a / 60
      @recentmatchtext += a.to_s + (b<10 ? ":0" : ":") + b.to_s + ","
    end
    @recentmatchtext += $diffname_table[item.difftype%4].to_s + ","
    @recentmatchtext += (item.enemyname ? item.enemyname + "\r\n" : "\r\n")
    
    if @rm_create and @rm.alive? then
      @rm.text.caption = @recentmatchtext
      @rm.text.scrollTo(@rm.text.countLines,0)
    end
    refreshsheet
    show_total
    
    if @copynewreplay.checked? && item.difftype < 4
    #ϐ̏ꍇtɂȂĂ邱Ƃ̂
      case item.side
      when 0
        if ! search_new_replay(' vs ' + item.enemyname)
          search_new_replay(item.enemyname + ' vs ')
        end
      when 1
        if ! search_new_replay(item.enemyname + ' vs ')
          search_new_replay(' vs ' + item.enemyname)
        end
      end
    end
  end
  
#I
  def self_close
#j[oƃEBhEʒů炵̂ŕ␳
    $s["mainx"] = self.x - 4
    $s["mainy"] = self.y - 42
#͍ŋ߂̑ΐEBhE𓮂ۂBӖs
    if @rm_create && @rm.alive?
      $s["logshow"] = true
      if ($s["logx"] != @rm.x) || ($s["logy"] != @rm.y)
        $s["logx"] = @rm.x - 4
        $s["logy"] = @rm.y - 21
      else
        $s["logx"] = @rm.x
        $s["logy"] = @rm.y
      end
    end
    write_settingfile($settingfile)
    @logfile.close
    close
  end
  
#\̍XV
  def refreshsheet(newdata=false)
    unless newdata
      for i in 1..9
        name = "auto" + i.to_s
        next unless $s[name]
        set_params(name)
        $outfile = $s["output_filename" + i.to_s]
        sheet_show($s[name + "sheet"])
      end
    end
    
    set_params("")
    $outfile = $s["output_filename0"]
    sheet_show($s["sheet"])
  end
  
  def sheet_show(sheet)
    if @sort.checked?
      case sheet
      when "ΐ"
        @shukei.nmatch_show(true)
      when ""
        @shukei.nwin_show(true)
      when ""
        @shukei.winrate_show(true)
      when "ϑΐ펞ԁiEhj"
        @shukei.playtimeave_show(true)
      when "Œΐ펞ԁiꎎj"
        @shukei.playtimemax_show(true)
      when "Œΐ펞ԁiEhj"
        @shukei.playtimemaxR_show(3, true)
      when "Œΐ펞ԁi1Rj"
        @shukei.playtimemaxR_show(0, true)
      when "Œΐ펞ԁi2Rj"
        @shukei.playtimemaxR_show(1, true)
      when "Œΐ펞ԁi3Rj"
        @shukei.playtimemaxR_show(2, true)
      end
      return
    end
    
    case sheet
    when "ΐ"
      @shukei.nmatch_show
    when ""
      @shukei.nwin_show
    when ""
      @shukei.winrate_show
    when "ϑΐ펞ԁiEhj"
      @shukei.playtimeave_show
    when "Œΐ펞ԁiꎎj"
      @shukei.playtimemax_show
    when "s"
      @shukei.nwinloose_show
    when "s񐔏ڍ"
      @shukei.nwin2_show
    when "Œΐ펞ԁiEhj"
      @shukei.playtimemaxR_show(3)
    when "Œΐ펞ԁi1Rj"
      @shukei.playtimemaxR_show(0)
    when "Œΐ펞ԁi2Rj"
      @shukei.playtimemaxR_show(1)
    when "Œΐ펞ԁi3Rj"
      @shukei.playtimemaxR_show(2)
    
    when "BFΐ"
      @shukei.ach_0_2_show
    when "BF1-2ȏ"
      @shukei.ach_1_2_show
    when "BF2-1ȏ"
      @shukei.ach_2_1_show
    when "BF2-0"
      @shukei.ach_2_0_show
    when "BF"
      @shukei.ach_win_show
    
    when "BFςP"
      @shukei.ach_tave(90, sheet)
    when "BFςQ"
      @shukei.ach_tave(120, sheet)
    when "BFςQ"
      @shukei.ach_tave(150, sheet)
    when "BFςR"
      @shukei.ach_tave(180, sheet)
    when "BFςT"
      @shukei.ach_tave(300, sheet)
    when "BFŒQ"
      @shukei.ach_tmax(120, sheet)
    when "BFŒR"
      @shukei.ach_tmax(180, sheet)
    when "BFŒS"
      @shukei.ach_tmax(240, sheet)
    when "BFŒT"
      @shukei.ach_tmax(300, sheet)
    when "BFŒW"
      @shukei.ach_tmax(480, sheet)
    when "BFŒPO"
      @shukei.ach_tmax(600, sheet)
    
    else
    end
  end
  
#烁j[
  
#t@Cj[
  def openlog_clicked
    init_shukei
  end
  
  def save_clicked
    @init_finished = false
    if ! $s["savefile"]
      filename = SWin::CommonDialog::saveFilename(self,[ ["ۑt@C(*.txt)","*.txt"],["SẴt@C(*.*)","*.*"] ])
      return if ! filename
      $s["savefile"] = filename
    end
    Dir.chdir($current_dir)
    @shukei.save_shukei($s["savefile"])
    self_close
  end
  
  def exit_clicked
    self_close
  end
  
#\j[ƑI{^
  
#ՓxƑΐlA΂bnl̑I
  def easy_clicked
    @easy.checked = ! @easy.checked?
    $s["easy"] = ! $s["easy"]
    refreshsheet
    show_total
  end
  def normal_clicked
    @normal.checked = ! @normal.checked?
    $s["normal"] = ! $s["normal"]
    refreshsheet
    show_total
  end
  def hard_clicked
    @hard.checked = ! @hard.checked?
    $s["hard"] = ! $s["hard"]
    refreshsheet
    show_total
  end
  def luna_clicked
    @luna.checked = ! @luna.checked?
    $s["luna"] = ! $s["luna"]
    refreshsheet
    show_total
  end
  def human_clicked
    @human.checked = ! @human.checked?
    $s["human"] = ! $s["human"]
    refreshsheet
    show_total
  end
  def com_clicked
    @com.checked = ! @com.checked?
    $s["com"] = ! $s["com"]
    refreshsheet
    show_total
  end
  
#ՓxEΐl΂bnlI{^
  def uncheck_diff
    @easy.checked = false
    $s["easy"] = false
    @normal.checked = false
    $s["normal"] = false
    @hard.checked = false
    $s["hard"] = false
    @luna.checked = false
    $s["luna"] = false
  end
  def selectdiff_easyonly_clicked
    uncheck_diff
    @easy.checked = true
    $s["easy"] = true
    refreshsheet
    show_total
  end
  def selectdiff_normalonly_clicked
    uncheck_diff
    @normal.checked = true
    $s["normal"] = true
    refreshsheet
    show_total
  end
  def selectdiff_hardonly_clicked
    uncheck_diff
    @hard.checked = true
    $s["hard"] = true
    refreshsheet
    show_total
  end
  def selectdiff_lunaonly_clicked
    uncheck_diff
    @luna.checked = true
    $s["luna"] = true
    refreshsheet
    show_total
  end
  def selectdiff_diffall_clicked
    @easy.checked = true
    $s["easy"] = true
    @normal.checked = true
    $s["normal"] = true
    @hard.checked = true
    $s["hard"] = true
    @luna.checked = true
    $s["luna"] = true
    refreshsheet
    show_total
  end
  def selecttype_humanonly_clicked
    @human.checked = true
    $s["human"] = true
    @com.checked = false
    $s["com"] = false
    refreshsheet
    show_total
  end
  def selecttype_comonly_clicked
    @human.checked = false
    $s["human"] = false
    @com.checked = true
    $s["com"] = true
    refreshsheet
    show_total
  end
  def selecttype_typeboth_clicked
    @human.checked = true
    $s["human"] = true
    @com.checked = true
    $s["com"] = true
    refreshsheet
    show_total
  end
  def selecttype_opensheet_clicked
    filename = $s["output_filename0"]
#puts "debug", File.file?(filename), "start " + filename
#    IO.popen('start output.html')
    if File.file?(filename)
      IO.popen("start " + filename)
    end
  end
  
#\̑I
  def check_menuitem
    @easy.checked = $s["easy"]
    @normal.checked = $s["normal"]
    @hard.checked = $s["hard"]
    @luna.checked = $s["luna"]
    @human.checked = $s["human"]
    @com.checked = $s["com"]
    
    @nmatch.checked = false
    @nwin.checked = false
    @winrate.checked = false
    @playtimeave.checked = false
    @playtimemax.checked = false
    @nwinloose.checked = false
    @nwin2.checked = false
    @playtimemaxR.checked = false
    @playtimemax1R.checked = false
    @playtimemax2R.checked = false
    @playtimemax3R.checked = false
    
    @ach_0_2.checked = false
    @ach_1_2.checked = false
    @ach_2_1.checked = false
    @ach_2_0.checked = false
    @ach_win.checked = false
    
    @ach_tave90.checked = false
    @ach_tave120.checked = false
    @ach_tave150.checked = false
    @ach_tave180.checked = false
    @ach_tave300.checked = false
    @ach_tmax120.checked = false
    @ach_tmax180.checked = false
    @ach_tmax240.checked = false
    @ach_tmax300.checked = false
    @ach_tmax480.checked = false
    @ach_tmax600.checked = false
    
    case $s["sheet"]
    when "ΐ"
      @nmatch.checked = true
    when ""
      @nwin.checked = true
    when "s"
      @nwinloose.checked = true
    when ""
      @winrate.checked = true
    when "ϑΐ펞ԁiEhj"
      @playtimeave.checked = true
    when "Œΐ펞ԁiEhj"
      @playtimemaxR.checked = true
    
    when "Œΐ펞ԁi1Rj"
      @playtimemax1R.checked = true
    when "Œΐ펞ԁi2Rj"
      @playtimemax2R.checked = true
    when "Œΐ펞ԁi3Rj"
      @playtimemax3R.checked = true
    when "Œΐ펞ԁiꎎj"
      @playtimemax.checked = true
    when "s񐔏ڍ"
      @nwin2.checked = true
    when "BFΐ"
      @ach_0_2.checked = true
    when "BF1-2ȏ"
      @ach_1_2.checked = true
    when "BF2-1ȏ"
      @ach_2_1.checked = true
    when "BF2-0"
      @ach_2_0.checked = true
    when "BF"
      @ach_win.checked = true
    when "BFςP"
      @ach_tave90.checked = true
    when "BFςQ"
      @ach_tave120.checked = true
    when "BFςQ"
      @ach_tave150.checked = true
    when "BFςR"
      @ach_tave180.checked = true
    when "BFςT"
      @ach_tave300.checked = true
    when "BFŒQ"
      @ach_tmax120.checked = true
    when "BFŒR"
      @ach_tmax180.checked = true
    when "BFŒS"
      @ach_tmax240.checked = true
    when "BFŒT"
      @ach_tmax300.checked = true
    when "BFŒW"
      @ach_tmax480.checked = true
    when "BFŒPO"
      @ach_tmax600.checked = true
    end
  end
  
  def nmatch_clicked
    $s["sheet"] = "ΐ"
    check_menuitem
    refreshsheet
  end
  def nwin_clicked
    $s["sheet"] = ""
    check_menuitem
    refreshsheet
  end
  def nwinloose_clicked
    $s["sheet"] = "s"
    check_menuitem
    refreshsheet
  end
  def winrate_clicked
    $s["sheet"] = ""
    check_menuitem
    refreshsheet
  end
  def playtimeave_clicked
    $s["sheet"] = "ϑΐ펞ԁiEhj"
    check_menuitem
    refreshsheet
  end
  def playtimemaxR_clicked
    $s["sheet"] = "Œΐ펞ԁiEhj"
    check_menuitem
    refreshsheet
  end

  def playtimemax1R_clicked
    $s["sheet"] = "Œΐ펞ԁi1Rj"
    check_menuitem
    refreshsheet
  end
  def playtimemax2R_clicked
    $s["sheet"] = "Œΐ펞ԁi2Rj"
    check_menuitem
    refreshsheet
  end
  def playtimemax3R_clicked
    $s["sheet"] = "Œΐ펞ԁi3Rj"
    check_menuitem
    refreshsheet
  end
  def playtimemax_clicked
    $s["sheet"] = "Œΐ펞ԁiꎎj"
    check_menuitem
    refreshsheet
  end
  def nwin2_clicked
    $s["sheet"] = "s񐔏ڍ"
    check_menuitem
    refreshsheet
  end
  def ach_0_2_clicked
    $s["sheet"] = "BFΐ"
    check_menuitem
    refreshsheet
  end
  def ach_1_2_clicked
    $s["sheet"] = "BF1-2ȏ"
    check_menuitem
    refreshsheet
  end
  def ach_2_1_clicked
    $s["sheet"] = "BF2-1ȏ"
    check_menuitem
    refreshsheet
  end
  def ach_2_0_clicked
    $s["sheet"] = "BF2-0"
    check_menuitem
    refreshsheet
  end
  def ach_win_clicked
    $s["sheet"] = "BF"
    check_menuitem
    refreshsheet
  end
  def ach_tave90_clicked
    $s["sheet"] = "BFςP"
    check_menuitem
    refreshsheet
  end
  def ach_tave120_clicked
    $s["sheet"] = "BFςQ"
    check_menuitem
    refreshsheet
  end
  def ach_tave150_clicked
    $s["sheet"] = "BFςQ"
    check_menuitem
    refreshsheet
  end
  def ach_tave180_clicked
    $s["sheet"] = "BFςR"
    check_menuitem
    refreshsheet
  end
  def ach_tave300_clicked
    $s["sheet"] = "BFςT"
    check_menuitem
    refreshsheet
  end
  def ach_tmax120_clicked
    $s["sheet"] = "BFŒQ"
    check_menuitem
    refreshsheet
  end
  def ach_tmax180_clicked
    $s["sheet"] = "BFŒR"
    check_menuitem
    refreshsheet
  end
  def ach_tmax240_clicked
    $s["sheet"] = "BFŒS"
    check_menuitem
    refreshsheet
  end
  def ach_tmax300_clicked
    $s["sheet"] = "BFŒT"
    check_menuitem
    refreshsheet
  end
  def ach_tmax480_clicked
    $s["sheet"] = "BFŒW"
    check_menuitem
    refreshsheet
  end
  def ach_tmax600_clicked
    $s["sheet"] = "BFŒPO"
    check_menuitem
    refreshsheet
  end
  
  
#c[j[
  
#ŋ߂̑ΐ̕\
  def recentmatch_clicked
    return if @rm_create && @rm.alive?
    @rm_create = true
    @rm = VRLocalScreen.modelessform(self,nil,RecentMatch)
    @rm.caption = "ŋ߂̑ΐ"
    @recentmatchtext = ""
    @rm.text.scrollTo(@rm.text.countLines,0)
  end
  
#Oɑΐǉimɂ́AǉOVɍj
  def add_date_clicked
    if @add_date.checked?
      @logfile2.close
      @add_date.checked = false
      $s["add_date"] = false
    else
      begin
        @init_finished = false
        if File.exist?($s["logfile2"]) then
          @logfile2 = open($s["logfile2"],"a")
        else
          logfile = open($s["logfile"],"r")
          @logfile2 = open($s["logfile2"],"w")
          line = @logfile.gets
          @logfile2.puts line.chomp + ",ΐ"
          while line = logfile.gets
            @logfile2.puts line.chomp + ","
          end
          logfile.close
          @logfile2.flush
        end
        @init_finished = true
      rescue
        return
      end
      @add_date.checked = true
      $s["add_date"] = true
    end
  end
  
#VKvCKɃl[ăvCtH_ɔzu
  def copynewreplay_clicked
    @copynewreplay.checked = ! @copynewreplay.checked?
    $s["copy_new_replay"] = ! $s["copy_new_replay"]
  end
  
#ݒ胁j[
  
#
  def total_recent_clicked
    return if$s["total_limit"] < 1
    @total_recent.checked = ! @total_recent.checked?
    $s["total_recent"] = ! $s["total_recent"]
    show_total
  end
#\[g̗L
  def sort_clicked
    @sort.checked = ! @sort.checked?
    $s["sort"] = ! $s["sort"]
    refreshsheet
  end
#JX^i璷ǓZ߂itȂj
  def co0_clicked
    if $s["co0"]
      change_params("co0")
      refreshsheet
      show_total
    end
  end
  def co1_clicked
    if $s["co1"]
      change_params("co1")
      refreshsheet
      show_total
    end
  end
  def co2_clicked
    if $s["co2"]
      change_params("co2")
      refreshsheet
      show_total
    end
  end
  def co3_clicked
    if $s["co3"]
      change_params("co3")
      refreshsheet
      show_total
    end
  end
  def co4_clicked
    if $s["co4"]
      change_params("co4")
      refreshsheet
      show_total
    end
  end
  def co5_clicked
    if $s["co5"]
      change_params("co5")
      refreshsheet
      show_total
    end
  end
  def co6_clicked
    if $s["co6"]
      change_params("co6")
      refreshsheet
      show_total
    end
  end
  def co7_clicked
    if $s["co7"]
      change_params("co7")
      refreshsheet
      show_total
    end
  end
  def co8_clicked
    if $s["co8"]
      change_params("co8")
      refreshsheet
      show_total
    end
  end
  def co9_clicked
    if $s["co9"]
      change_params("co9")
      refreshsheet
      show_total
    end
  end
  
  def custom0_clicked
    if $s["custom0"]
      change_params("custom0")
      check_menuitem
      refreshsheet
      show_total
    end
  end
  def custom1_clicked
    if $s["custom1"]
      change_params("custom1")
      check_menuitem
      refreshsheet
      show_total
    end
  end
  def custom2_clicked
    if $s["custom2"]
      change_params("custom2")
      check_menuitem
      refreshsheet
      show_total
    end
  end
  def custom3_clicked
    if $s["custom3"]
      change_params("custom3")
      check_menuitem
      refreshsheet
      show_total
    end
  end
  def custom4_clicked
    if $s["custom4"]
      change_params("custom4")
      check_menuitem
      refreshsheet
      show_total
    end
  end
  def custom5_clicked
    if $s["custom5"]
      change_params("custom5")
      check_menuitem
      refreshsheet
      show_total
    end
  end
  def custom6_clicked
    if $s["custom6"]
      change_params("custom6")
      check_menuitem
      refreshsheet
      show_total
    end
  end
  def custom7_clicked
    if $s["custom7"]
      change_params("custom7")
      check_menuitem
      refreshsheet
      show_total
    end
  end
  def custom8_clicked
    if $s["custom8"]
      change_params("custom8")
      check_menuitem
      refreshsheet
      show_total
    end
  end
  def custom9_clicked
    if $s["custom9"]
      change_params("custom9")
      check_menuitem
      refreshsheet
      show_total
    end
  end
  
  def save_custom0_clicked
    $s["custom0caption"] = "JX^ݒ0"
    register_custom("custom0")
  end
  def save_custom1_clicked
    $s["custom1caption"] = "JX^ݒ1"
    register_custom("custom1")
  end
  def save_custom2_clicked
    $s["custom2caption"] = "JX^ݒ2"
    register_custom("custom2")
  end
  def save_custom3_clicked
    $s["custom3caption"] = "JX^ݒ3"
    register_custom("custom3")
  end
  def save_custom4_clicked
    $s["custom4caption"] = "JX^ݒ4"
    register_custom("custom4")
  end
  def save_custom5_clicked
    $s["custom5caption"] = "JX^ݒ5"
    register_custom("custom5")
  end
  def save_custom6_clicked
    $s["custom6caption"] = "JX^ݒ6"
    register_custom("custom6")
  end
  def save_custom7_clicked
    $s["custom7caption"] = "JX^ݒ7"
    register_custom("custom7")
  end
  def save_custom8_clicked
    $s["custom8caption"] = "JX^ݒ8"
    register_custom("custom8")
  end
  def save_custom9_clicked
    $s["custom9caption"] = "JX^ݒ9"
    register_custom("custom9")
  end
end


#ՓxEΐl΂bnlI{^
class SelectDiff < VRPanel
  include VRHorizLayoutManager
  include VRStdControlContainer
  
  def construct
    addControl(VRButton,"easyonly","Easy")
    addControl(VRButton,"normalonly","Normal")
    addControl(VRButton,"hardonly","Hard")
    addControl(VRButton,"lunaonly","Luna")
    addControl(VRButton,"diffall","S")
    
    send_parent("easyonly","clicked")
    send_parent("normalonly","clicked")
    send_parent("hardonly","clicked")
    send_parent("lunaonly","clicked")
    send_parent("diffall","clicked")
  end
end

class SelectType < VRPanel
  include VRHorizLayoutManager
  include VRStdControlContainer
  
  def construct
    addControl(VRButton,"humanonly","ΐl")
    addControl(VRButton,"comonly","΂bnl")
    addControl(VRButton,"typeboth","")
    addControl(VRStatic,"","")
    addControl(VRButton,"opensheet","\J")
    
    send_parent("humanonly","clicked")
    send_parent("comonly","clicked")
    send_parent("typeboth","clicked")
    send_parent("opensheet","clicked")
  end
end

#ŋ߂̑ΐEBhE
module RecentMatch
  attr_accessor :text
  def construct
    @text = addControl(VRText,"text","",0,0,500,300,WStyle::WS_VSCROLL)
    move $s["logx"],$s["logy"],500,320
  end
end

#JX^IEBhE



frm=VRLocalScreen.newform
frm.extend HKShowMenu

frm.create.show

VRLocalScreen.messageloop
